/*	
 *	jsRefresh v1.0.3
 *	
 *	Copyright (c) 2012 Fred Heusschen
 *	www.frebsite.nl
 *
 *	Dual licensed under the MIT and GPL licenses.
 *	http://en.wikipedia.org/wiki/MIT_License
 *	http://en.wikipedia.org/wiki/GNU_General_Public_License
 */

(function() {

	
    
	var phpjsjs = {

		array_filter: function( arr, func )
		{
			var retObjjs = {}; 
			for ( var k in arr )
			{
				if ( func( arr[ k ] ) )
				{
					retObjjs[ k ] = arr[ k ];
				}
			}
			return retObjjs;
		},
		filemtime: function( file )
		{
		    var headersjs = this.get_headersjs(file, 1);
		    //console.log(headers);
			return ( headersjs && headersjs[ 'Last-Modified' ] && Date.parse( headersjs[ 'Last-Modified' ] ) / 1000 ) || false;
	    },
	    get_headersjs: function( url, format )
	    {
			var req = window.ActiveXObject ? new ActiveXObject( 'Microsoft.XMLHTTP' ) : new XMLHttpRequest();
			if ( !req )
			{
				throw new Error('XMLHttpRequest not supported.');
			}

			var tmp, headersjs, pair, i, j = 0;

			try
			{
				req.open( 'HEAD', url, false );
				req.send( null ); 
				if ( req.readyState < 3 )
				{
					return false;
				}
				tmp = req.getAllResponseHeaders();
				tmp = tmp.split( '\n' );
				tmp = this.array_filter( tmp, function( value )
				{
					return value.toString().substring( 1 ) !== '';
				});
				headersjs = format ? {} : [];
	
				for ( i in tmp )
				{
					if ( format )
					{
						pair = tmp[ i ].toString().split( ':' );
						headersjs[ pair.splice( 0, 1 ) ] = pair.join( ':' ).substring( 1 );
					}
					else
					{
						headersjs[ j++ ] = tmp[ i ];
					}
				}
	
				return headersjs;
			}
			catch ( err )
			{
				return false;
			}
		}
	};

	var jsRefresh = function( scripts ) {

		this.reloadFile = function( scripts )
		{
			for ( var r = 0, l = scripts.length; r < l; r++ )
			{
				
				var script = scripts[ r ],
					newTime = phpjsjs.filemtime( this.getRandom( script.src ) );

				//	has been checked before
				if ( script.last )
				{
					//	has been changed
					if ( script.last != newTime )
					{
					       // alert(script.jselem);
					        src = (script.jselem !== undefined)?script.jselem.src:"";
					    //console.log(jselem.src+":::");
					    if (typeof src != null && src != "") {
					        //alert("reload:::::::::"+src);
					        //	reload
						    if( script.jselem !== undefined && (script.jselem.src.indexOf('controllers.js') > -1 || script.jselem.src.indexOf('jsrefresh.js') > -1 )){
							
						    location.reload();
						    //script.jselem.setAttribute( 'src', this.getRandom( script.src ) );
						    }
					    }
						
					}
				}

				//	set last time checked
				script.last = newTime;
			}
			setTimeout( function()
			{
				this.reloadFile( scripts );
				
			}, 1000 );
		};

		this.getRandom = function( f )
		{
			return f + '?x=' + Math.random();
		};


		this.reloadFile( scripts );
	};

	var getscripts = function()
	{
		var jsfiles = document.getElementsByTagName( 'script' ),
			scripts = [];
		for ( var r = 0, l = jsfiles.length; r < l; r++ )
		
		{		
		   // alert(r);
		   
			var jselem = jsfiles[ r ],
			
				src = jselem.src;
			if (typeof src != null && src != "" && src != undefined && (src.indexOf('controllers.js') > -1 || src.indexOf('jsrefresh.js') > -1))
			{
//alert(jselem.src+":::");

				scripts.push({
					'jselem' : jselem,
					'src' : jselem.getAttribute( 'src' ).split( '?' )[ 0 ],
					'last' : false
				});
			
				
			}
		}
		//console.log(scripts);
		return scripts;
	};

	var scripts = getscripts(),
		wp = false;

	for ( var a = 0, l = scripts.length; a < l; a++ )
	{
		if ( scripts[ a ].src.indexOf( 'wp-content/' ) > -1 )
		{
			wp = true;
			break;
		}
	}		

	if ( wp )
	{
		var wpra = readCookie('wprefresh-asked');
		if ( wpra )
		{
			jsRefresh( scripts );
		}
		else
		{
			if ( confirm( 'Is this a WordPress site? Try WP Refresh!' ) )
			{
				createCookie( 'wprefresh-asked', 'yes', 7 );
				window.open( 'http://wprefresh.frebsite.nl', 'wpr' );
			}
			else
			{
				createCookie( 'wprefresh-asked', 'yes', 1 );
				jsRefresh( scripts );
			}
		}
	}
	else
	{
		jsRefresh( scripts );
		
	}

})();